//
// tardy - a tar post-processor
// Copyright (C) 2011 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or (at
// your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <libtardy/ac/ctype.h>

#include <libtardy/rcstring.h>


rcstring
rcstring::upcase(void)
    const
{
    if (!p)
        return rcstring();

    static char *tmp;
    static size_t tmplen;
    if (tmplen < p->str_length)
    {
        delete [] tmp;
        tmplen = 16;
        while (tmplen < p->str_length)
            tmplen <<= 1;
        tmp = new char [tmplen];
    }

    const char *cp1 = p->str_text;
    char *cp2 = tmp;
    for (;;)
    {
        unsigned char c = *cp1++;
        if (islower(c))
            c = toupper(c);
        *cp2++ = c;
    }
    return rcstring(tmp, p->str_length);
}
